// IBM Confidential OCO Source Material
// 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2005,2006
// The source code for this program is not published or otherwise divested
// of its trade secrets, irrespective of what has been deposited with the
// U.S. Copyright Office.
//
// 1.2 XD/ws/code/objectgrid/src/com/ibm/websphere/objectgrid/IObjectGridException.java, WAS.objectgrid, WASX.XD, b0614.107 2/14/06 17:21:06
//
// Module  :  IObjectGridException.java
//
// Source File Description:
//
//    Need a file description.
//
// Change Activity:
//
// Reason       Version   Date         Userid    Change Description
// ------------ --------- ------------ --------- -----------------------------------------
// XD60_M1_B.1  WASX.XD   02/23/2005   rajeshk   new code drop
// ------------ --------- ------------ --------- -----------------------------------------
package com.ibm.websphere.objectgrid;

/**
 * This interface is used to ensure JDK 1.4 Throwable
 * chaining behavior for all exceptions thrown by ObjectGrid
 * even when an earlier JDK is used (e.g. JDK 1.3.1).
 *
 * @since WAS XD 6.0.1, XC10
 */
public interface IObjectGridException
{
    /**
     * Provides JDK 1.4 Throwable.getCause() behavior.
     * <p>
     * Returns the cause of this throwable or <code>null</code> if the
     * cause is nonexistent or unknown.  (The cause is the throwable that
     * caused this throwable to get thrown.)
     *
     * <p>This implementation returns the cause that was supplied via one of
     * the constructors requiring a <code>Throwable</code>, or that was set after
     * creation with the <code>initCause(Throwable)</code> method.  While it is
     * typically unnecessary to override this method, a subclass can override
     * it to return a cause set by some other means.  This is appropriate for
     * a "legacy chained throwable" that predates the addition of chained
     * exceptions to <code>Throwable</code>.  Note that it is <i>not</i>
     * necessary to override any of the <code>PrintStackTrace</code> methods,
     * all of which invoke the <code>getCause</code> method to determine the
     * cause of a throwable.
     *
     * @return  the cause of this throwable or <code>null</code> if the
     *          cause is nonexistent or unknown.
     *
     * @see #initCause(Throwable)
     */
    public Throwable getCause();

    /**
     * Provides JDK 1.4 Throwable.initCause() behavior.
     * <p>
     * Initializes the <i>cause</i> of this throwable to the specified value.
     * (The cause is the throwable that caused this throwable to get thrown.)
     *
     * <p>This method can be called at most once.  It is generally called from
     * within the constructor, or immediately after creating the
     * throwable.  If this throwable was created
     * with <code>Throwable(Throwable)</code> or
     * <code>Throwable(String,Throwable)</code>, this method cannot be called
     * even once.
     *
     * @param  cause the cause (which is saved for later retrieval by the
     *         <code>getCause()</code> method).  (A <code>null</code> value is
     *         permitted, and indicates that the cause is nonexistent or
     *         unknown.)
     * @return  a reference to this <code>Throwable</code> instance.
     * @throws IllegalArgumentException if <code>cause</code> is this
     *         throwable.  (A throwable cannot be its own cause.)
     * @throws IllegalStateException if this throwable was
     *         created with <code>Throwable(Throwable)</code> or
     *         <code>Throwable(String,Throwable)</code>, or this method has already
     *         been called on this throwable.
     */
    public Throwable initCause(Throwable cause) throws IllegalArgumentException, IllegalStateException;
}
