// IBM Confidential OCO Source Material
// 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2005,2006
// The source code for this program is not published or otherwise divested
// of its trade secrets, irrespective of what has been deposited with the
// U.S. Copyright Office.
//
// 1.2 XD/ws/code/objectgrid/src/com/ibm/websphere/objectgrid/SessionNotReentrantException.java, WAS.objectgrid, WASX.XD, b0614.107 2/14/06 17:25:36
//
// Module : SessionNotReentrantException.java
//
// Source File Description:
//
//     See javadoc for class.
//
// Change Activity:
//
// Reason       Version  Date        Userid   Change Description
// ------------ -------- ----------- -------  ------------------------
// XD601_M2_B.x WASX.XD  Nov 22, 2005 kjlaw    new class.
// -------------------------------------------------------------------
//
package com.ibm.websphere.objectgrid;

/**
 * A Session object can only be used by a single thread
 * concurrently to perform map operations.  If a thread tries
 * to execute a map operation (for example, call a method on
 * ObjectMap interface) while another thread is already
 * executing a map operation for the Session, then this
 * exception is thrown.
 *
 * @since WAS XD 6.0.1, XC10
 */
public class SessionNotReentrantException extends TransactionException
{
    /**
     * The <code>serialVersionUID</code> for this class.
     */
    private static final long serialVersionUID = -2056808551241984518L;

    /**
     * Constructs a new SessionNotReentrantException with the specified detail message and
     * a special indication of whether the transaction was rolled back as a result
     * of this exception. The cause is not initialized, and may subsequently be
     * initialized by a call to the <code>initCause</code> method.
     *
     * @param message
     *           the detail message. The detail message is saved for later
     *           retrieval by the <code>getMessage</code> method.
     * @param rolledBack
     *           A value of <code>true</code> indicates the transaction was rolled back.
     *
     * @see #initCause(Throwable)
     * @see #getMessage()
     * @see #wasTransactionRolledBack()
     */
    public SessionNotReentrantException(String message, boolean rolledBack) {
        super(message, rolledBack);
    }
}
